;; logistics domain Typed version.
;;

(define (domain logistics)
  (:requirements :strips :typing) 
  (:types truck
          airplane
          package
          location
          city)
  
  (:predicates 	(in-city ?loc - location ?city - city)
		(at-package ?obj - package ?loc - location)
		(at-truck ?t - truck ?loc - location)
		(at-airplane ?a - airplane ?loc - location)
		(in-airplane ?pkg - package ?veh - airplane)
		(in-truck ?pkg - package ?veh - truck)
		)
  
  (:action LOAD-TRUCK
	   :parameters    (?pkg - package ?truck - truck ?loc - location)
	   :precondition  (and (at-truck ?truck ?loc) (at-package ?pkg ?loc))
	   :effect        (and (not (at-package ?pkg ?loc)) (in-truck ?pkg ?truck)))

(:action LOAD-AIRPLANE
  :parameters   (?pkg - package ?airplane - airplane ?loc - location)
  :precondition (and (at-package ?pkg ?loc) (at-airplane ?airplane ?loc))
  :effect       (and (not (at-package ?pkg ?loc)) (in-airplane ?pkg ?airplane)))

(:action UNLOAD-TRUCK
  :parameters   (?pkg - package ?truck - truck ?loc - location)
  :precondition (and (at-truck ?truck ?loc) (in-truck ?pkg ?truck))
  :effect       (and (not (in-truck ?pkg ?truck)) (at-package ?pkg ?loc)))

(:action UNLOAD-AIRPLANE
  :parameters    (?pkg - package ?airplane - airplane ?loc - location)
  :precondition  (and (in-airplane ?pkg ?airplane) (at-airplane ?airplane ?loc))
  :effect (and (not (in-airplane ?pkg ?airplane)) (at-package ?pkg ?loc)))

(:action DRIVE-TRUCK
  :parameters (?truck - truck ?loc-from - location ?loc-to - location ?city - city)
  :precondition
   (and (at-truck ?truck ?loc-from) (in-city ?loc-from ?city) (in-city ?loc-to ?city))
   :effect (and (not (at-truck ?truck ?loc-from))
		(at-truck ?truck ?loc-to)))

(:action FLY-AIRPLANE
  :parameters (?airplane - airplane ?loc-from - location ?loc-to - location)
  :precondition (at-airplane ?airplane ?loc-from)
  :effect (and (not (at-airplane ?airplane ?loc-from))
	       (at-airplane ?airplane ?loc-to)))
)
