
(defun all-permutations (list)
  (cond ((null list) nil)
        ((null (cdr list)) (list list))
        (t (loop for element in list
             append (mapcar (lambda (l) (cons element l))
                            (all-permutations (remove element
                                                      list)))))))
(defun next-step (list)
  (nth (random (length list)) list))


(defun shuffle-plan-one-step (plan)
  (let ((pivot (first plan))
        (swap (random (length (rest plan)))))
    (setf (nth 0 plan) (nth swap (rest plan)))
    (setf (nth swap (rest plan)) pivot)
    plan))

(defun put-trucks-at-locations (truck-num locations)
  (loop for i from 1 to truck-num
        collect `(at-truck ,(intern (format nil "TRU~a" i))
                    ,(next-step locations))))
          
(defun problem-instance (truck-num)
  (let ()
    `(define (problem prob)
         (:domain logistics)
       (:objects
        apn1 - airplane
        apt1 apt2 pos2 pos1 - location
        cit2 cit1 - city
        ,@(loop for i from 1 to truck-num
                collect (intern (format nil "TRU~a" i))) - truck
        obj23 obj22 obj21 obj13 obj12 obj11 - package)
       (:init
        ,@(put-trucks-at-locations truck-num '(pos1 pos2))
        (at-airplane apn1 apt2) 
        (at-package obj11 pos1)
        (at-package obj12 pos1) 
        (at-package obj13 pos1) 
        (at-package obj21 pos2) 
        (at-package obj22 pos2)
        (at-package obj23 pos2) 
        (in-city pos1 cit1) (in-city apt1 cit1) (in-city pos2 cit2)
        (in-city apt2 cit2))       
    (:goal (and (at-package obj11 apt1) (at-package obj23 pos1) (at-package obj13 apt1) (at-package obj21 pos1))))))


(defun logistics-problems (truck-num problem-num output-directory
                           &key (goal-type :single))
  (loop for i from 1 to problem-num
        as problem = (problem-instance truck-num)
        do (with-open-file (str (format nil "~a/prob~a.pddl" 
                                  output-directory i)
                                :direction :output
                                :if-exists :supersede)
             (pprint problem str))))

